local Scalar = select(2, ...)
local Scalar = LibStub("AceAddon-3.0"):NewAddon(Scalar,"Scalar", "AceConsole-3.0","AceEvent-3.0")
local AceGUI = LibStub("AceGUI-3.0")
Scalar.version = GetAddOnMetadata("Scalar", "Version")

Scalar.FrameShown = false

local savedDBDefaults = { --- Default the saved variables
	global = {
		BagScale = 1.0,
		BankScale = 1.0,
		GBankScale =  1.0,
		VoidStorageScale = 1.0,
	},
}

Scalar:RegisterChatCommand("Scalar", "LoadGUI")


function Scalar:OnInitialize()	
	Scalar.db = LibStub:GetLibrary("AceDB-3.0"):New("ScalarDB", savedDBDefaults, true)
	Scalar:RegisterEvent("BANKFRAME_OPENED","ScaleBank")
	Scalar:RegisterEvent("GUILDBANKFRAME_OPENED","ScaleGBank")
	Scalar:RegisterEvent("VOID_STORAGE_OPEN","ScaleVStorage")
end

function Scalar:LoadGUI()
	if  Scalar.FrameShown == false then
		Scalar.FrameShown = true
		
		Scalar.frame = AceGUI:Create("Frame")
		Scalar.frame:SetTitle("Scalar")
		Scalar.frame:SetStatusText("Scalar version "..Scalar.version)
		Scalar.frame:EnableResize(false)
		Scalar.frame:SetWidth(300)
		Scalar.frame:SetHeight(300)
		Scalar.frame:SetLayout("List")
		Scalar.frame:SetCallback("OnClose", function(widget) AceGUI:Release(widget) Scalar.FrameShown = false end)
		
		
		Scalar.BagScaleSlider = AceGUI:Create("Slider")
		Scalar.BagScaleSlider:SetLabel("Bag Scale(on combat log event)")
		Scalar.BagScaleSlider:SetValue(Scalar.db.global.BagScale)
		Scalar.BagScaleSlider:SetSliderValues(0.1, 2.0, 0.1)
		Scalar.BagScaleSlider:SetCallback("OnValueChanged", function(value)
			Scalar:RunUpdateSV()
			Scalar:ScaleBags()
		end)
		Scalar.frame:AddChild(Scalar.BagScaleSlider)
		
		Scalar.BankScaleSlider = AceGUI:Create("Slider")
		Scalar.BankScaleSlider:SetLabel("Bank Scale")
		Scalar.BankScaleSlider:SetValue(Scalar.db.global.BankScale)
		Scalar.BankScaleSlider:SetSliderValues(0.1, 2.0, 0.1)
		Scalar.BankScaleSlider:SetCallback("OnValueChanged", function(value)
			Scalar:RunUpdateSV()
			Scalar:ScaleBank()
		end)
		Scalar.frame:AddChild(Scalar.BankScaleSlider)
		
		Scalar.GBankScaleSlider = AceGUI:Create("Slider")
		Scalar.GBankScaleSlider:SetLabel("Guild Bank Scale")
		Scalar.GBankScaleSlider:SetValue(Scalar.db.global.GBankScale)
		Scalar.GBankScaleSlider:SetSliderValues(0.1, 2.0, 0.1)
		Scalar.GBankScaleSlider:SetCallback("OnValueChanged", function(value)
			Scalar:RunUpdateSV()
			Scalar:ScaleGBank()
		end)
		Scalar.frame:AddChild(Scalar.GBankScaleSlider)
				
		Scalar.VStorageScaleSlider = AceGUI:Create("Slider")
		Scalar.VStorageScaleSlider:SetLabel("Void Storage Scale")
		Scalar.VStorageScaleSlider:SetValue(Scalar.db.global.VoidStorageScale)
		Scalar.VStorageScaleSlider:SetSliderValues(0.1, 2.0, 0.1)
		Scalar.VStorageScaleSlider:SetCallback("OnValueChanged", function(value)
			Scalar:RunUpdateSV()
			Scalar:ScaleVStorage()
		end)
		Scalar.frame:AddChild(Scalar.VStorageScaleSlider)
		
	elseif Scalar.FrameShown == true then
		Scalar.FrameShown = false
		AceGUI:Release(Scalar.frame)
	end
end

function Scalar:RunUpdateSV()
	Scalar.db.global.BagScale = Scalar.BagScaleSlider:GetValue()
	Scalar.db.global.BankScale = Scalar.BankScaleSlider:GetValue()
	Scalar.db.global.GBankScale = Scalar.GBankScaleSlider:GetValue()
	Scalar.db.global.VoidStorageScale = Scalar.VStorageScaleSlider:GetValue()
end

function Scalar:ScaleBags()
        for i=1, 13 do
                local frame = _G["ContainerFrame"..i]
                frame:SetScale(Scalar.db.global.BagScale)
        end
end

function Scalar:ScaleBank()
	if(BankFrame and  BankFrame:IsShown())  then
                BankFrame:SetScale(Scalar.db.global.BankScale)
        end
end

function Scalar:ScaleGBank()
	if(GuildBankFrame and GuildBankFrame:IsShown()) then
		GuildBankFrame:SetScale(Scalar.db.global.GBankScale)
	end
end

function Scalar:ScaleVStorage()
	if(VoidStorageFrame and VoidStorageFrame:IsShown()) then
		VoidStorageFrame:SetScale(Scalar.db.global.VoidStorageScale)
	end
end

local frame = CreateFrame("Frame")
frame:SetScript("OnUpdate", function(frame, time_since_last)
	Scalar:ScaleBags()
end)